package pp.s1184725.boppi;

import org.antlr.v4.runtime.tree.ParseTreeProperty;

import pp.iloc.model.Reg;

/**
 * This class holds properties of all AST nodes during compilation.
 *
 */
public class Annotations {
	/**
	 * Maps nodes to registers.
	 */
	public ParseTreeProperty<Reg> registers;
	/**
	 * Maps nodes to {@link SimpleType}s.
	 */
	public ParseTreeProperty<SimpleType> types;
	/**
	 * Maps nodes to {@link Variable}s.
	 */
	public ParseTreeProperty<Variable<SimpleType>> variables;

	/**
	 * Creates a new annotations object with empty maps.
	 */
	public Annotations() {
		registers = new ParseTreeProperty<>();
		types = new ParseTreeProperty<>();
		variables = new ParseTreeProperty<>();
	}
}
